ayit第十四周训练f题

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033
1733
3733
3739
3779
8779
8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0
#include<stdio.h>
#include<math.h>
#include<string.h>
int a,b,s;
int book[100010];
struct Nodes
{
	int x;
	int s;
}q[10100];
int p1(int x)
{
	int i,k;
	k=sqrt(x);
	for(i=2;i<=k;i++)
		if(x%i==0)
			break;
	if(i==k+1)
		return 1;
	else
		return 0;
}
void dfs(int a)
{
	memset(book,0,sizeof(book));
	int head,tail,ge,shi,bai,qian;
	head=1;tail=1;
	q[tail].x=a;
	q[tail].s=0;
	tail++;
	book[a]=1;
	int sum,i,flag=0;
	while(head<tail)
	{

		ge=q[head].x%10;
		shi=q[head].x/10%10;
		bai=q[head].x/100%10;
		qian=q[head].x/1000;

		for(i=1;i<=9;i+=2)
		{
			sum=qian*1000+bai*100+shi*10+i;
			if(p1(sum)&&book[sum]==0&&sum<10000)
			{
				book[sum]=1;
				q[tail].x=sum;
				q[tail].s=q[head].s+1;
				tail++;
				if(sum==b)
				{
					flag=1;
					break;
				}
			}
		}
		if(flag)
			break;
		for(i=0;i<=9;i++)
		{
			sum=qian*1000+bai*100+i*10+ge;
			if(p1(sum)&&book[sum]==0&&sum<10000)
			{
				book[sum]=1;
				q[tail].x=sum;
				q[tail].s=q[head].s+1;
				tail++;
				if(sum==b)
				{
					flag=1;
					break;
				}
			}
		}
		if(flag)
			break;
		for(i=0;i<=9;i++)
		{
			sum=qian*1000+i*100+shi*10+ge;
			if(p1(sum)&&book[sum]==0&&sum<10000)
			{
				book[sum]=1;
				q[tail].x=sum;
				q[tail].s=q[head].s+1;
				tail++;
				if(sum==b)
				{
					flag=1;
					break;
				}
			}
		}
		if(flag)
			break;
		for(i=1;i<=9;i++)
		{
			sum=i*1000+bai*100+shi*10+ge;
			if(p1(sum)&&book[sum]==0&&sum<10000)
			{
				book[sum]=1;
				q[tail].x=sum;
				q[tail].s=q[head].s+1;
				tail++;
				if(sum==b)
				{
					flag=1;
					break;
				}
			}
		}
		if(flag)
			break;
		head++;
	}
	if(!flag)
		printf("Impossible\n");
	else
		printf("%d\n",q[tail-1].s);
}
int main()
{
	int t;
	scanf("%d",&t);
	while(t--)
	{
		scanf("%d %d",&a,&b);
		if(a==b)
			printf("0\n");
		else
			dfs(a);
	}
	return 0;
}

题意   给你两个4位数,要求你每次只能变换一位数字,并且变换前后的数字都要满足是素数;求最少变换次数

思路   bfs和打表

猜你喜欢

转载自blog.csdn.net/m0_46628834/article/details/106326250